Package: smoother
Type: Package
Title: Functions Relating to the Smoothing of Numerical Data
Version: 1.3
Date: 2024-04-03
Author: Nicholas Hamilton
Maintainer: Nicholas Hamilton <n.hamilton@unsw.edu.au>
Description: A collection of methods for smoothing numerical data, commencing
    with a port of the Matlab gaussian window smoothing function. In addition,
    several functions typically used in smoothing of financial data are included.
License: GPL-2
Depends: TTR(>= 0.22)
Collate: 'onLoad.R' 'smoother-package.R' 'functions.R'
        'smth-gaussian.R' 'smth.R'
RoxygenNote: 7.3.1
NeedsCompilation: no
Packaged: 2024-04-02 23:09:56 UTC; nick
Repository: CRAN
Date/Publication: 2024-04-03 02:12:03 UTC

Smoother is a statistical tool for computing non-parametric distributions by optimizing a constrained smoothing function.

## Why smoother?

We often want to estimate a distribution given limited information, such as its mean and standard deviation. Rather than impose parametric assumptions, smoother uses non-parametric techniques to infer an entire distribution given limited information.

## Installation

```
$ pip install smoother
```

## Quickstart

```python
from smoother import Smoother, MomentConstraint

import matplotlib.pyplot as plt
import numpy as np

# fit a smooth distribution with given mean and standard deviation
lower_bound, upper_bound = -3, 3
mean_const = MomentConstraint(0, degree=1)
std_const = MomentConstraint(1, degree=2, type_='central', norm=True)
smoother = Smoother().fit(lower_bound, upper_bound, [mean_const, std_const])

# plot smoother pdf
x = np.linspace(lower_bound, upper_bound, num=100)
f_x = np.array([smoother.pdf(x_i) for x_i in x])
plt.plot(x, f_x)
```

The result should look like a normal distribution.

## Citation

```
@software{bowen2020smoother,
  author = {Dillon Bowen},
  title = {Smoother: a statistical package for computing smooth, non-parametric distributions},
  url = {https://dsbowen.github.io/smoother/},
  date = {2020-08-06},
}
```

## License

Users must cite this package in any publications which use it.

It is licensed with the MIT [License](https://github.com/dsbowen/smoother/blob/master/LICENSE).

#SOME UTILITY FUNCTIONS FOR USE IN THIS PACKAGE

#Function to determine the actual window length from possibly decimal (fractional) window length


.determineWindowLength = function (x, w) 
{
  if (!is.numeric(x) | !is.numeric(w)) {
    stop("Arguments 'x' and 'w' must be numeric")
  }
  l = length(x)
  w.orig = w
  if (w > 0 && w < 1) {
    w = w * l
  }
  ret = as.integer(max(abs(w[1]), 1))
  if (length(x) <= ret | ret < 1) {
    stop(paste("Resultant window length is out of range (", 
               ret, "), must be >= 1", sep = ""), call. = FALSE)
  }
  return(ret)
}

.normalize = function(x){
    if (!is.numeric(x)) {
      stop("argument 'x' must be numeric")
    }
    if (length(x) == 1) {
      return(1)
    }
    total = sum(x)
    if (total == 0) {
      stop("argument 'x' must not sum to zero")
    }
    return(x/total)
}

#' Smoother Options
#' 
#' @description Several Global Options have been declared, as described in this help file.
#' @details
#' The following global options can be modified, to alter the default calculation behaviour.
#' \tabular{lll}{
#' \strong{NAME} \tab \strong{VALUE} \tab \strong{DESCRIPTION} \cr
#'   \code{smoother.gaussianwindow.alpha} \tab \code{2.5} \tab Alpha Value in Calculating Window \cr
#'   \code{smoother.window} \tab \code{0.1} \tab Width of Window \cr
#'   \code{smoother.method} \tab \code{'gaussian'} \tab Default Smoothing Method \cr
#'   \code{smoother.tails} \tab \code{FALSE} \tab Include tails in final vector \cr
#'   \code{smoother.verbose} \tab \code{FALSE} \tab Verbose Reporting \cr
#' }
#' @examples
#' #Tighten the alpha term for this session.
#' options('smoother.gaussianwindow.alpha' = 1)
#' 
#' #Include the Tails in Final Calculation
#' options('smoother.tails' = TRUE)
#' 
#' @rdname smth.options
#' @name smth.options
NULL

.onLoad <- function(libname, pkgname){
  options('smoother.gaussianwindow.alpha' = 2.5)
  options('smoother.window' = 0.1)
  options('smoother.verbose'= FALSE)
  options('smoother.method' ='gaussian')
  options('smoother.tails'  = FALSE)
}

#' Smooth Data in R
#' 
#' @description \code{smoother} Package for the Smoothing of Numerical Data
#' 
#' @details \code{smoother} is presently limited to a port of the Matlab 'Gaussian Window' Function, 
#' as well as a limited number of moving averages (\code{sma, ema, dema} and \code{'wma'}). Code for the gaussian window 
#' function has been written locally within this package, however, the moving averages are called from the \link{TTR} package 
#' (\url{https://CRAN.R-project.org/package=TTR}) and are included as a matter of convenience.
#' 
#' For further information (and examples) with regards to utilizing the primary helper function, 
#' please refer to the \link{smth} function help file
#' 
#' @references The Gaussian Smoothing component of the \code{smoother} package has been loosley adapted from elsewhere
#' 
#' @name smoother
#' @rdname smoother
#' @aliases smoother
NULL

#' Smooth Using Gaussian Window
#' 
#' @description The specific function for smoothing using the gaussian window function
#' @param x numeric vector of values to smooth, error will be thrown if not provided.
#' @param window the length of the smoothing window, if an integer, represents
#' number of items, else, if a value between \code{0} and \code{1}, represents the 
#' proportion of the input vector
#' @param alpha parameter to determine the breadth of the gaussian window, yielding more or less sensitive 
#' smoothing characteristics
#' @param ... not used
#' @param tails Logical value as to whether the tail regions should be included or not.
#' @name   smth.gaussian
#' @rdname smth.gaussian
#' @examples
#'   y  = runif(100)
#'   ys = smth.gaussian(y)
#' @export
smth.gaussian <- function( x       = stop("Numeric Vector 'x' is Required"),
                           window  = getOption('smoother.window'),
                           alpha   = getOption('smoother.gaussianwindow.alpha'),
                           ...,
                           tails   = getOption('smoother.tails')){
  
  if (!is.numeric(x) | !is.numeric(alpha)) {
    stop("argument 'x' and 'alpha' must be numeric", call. = FALSE)
  }
  windowLength = .determineWindowLength(x, window)
  makeWindow = function(w, a) {
    hw = abs(w/2)
    e = exp(1)
    a = abs(a)
    ret = sapply(c(0:(w - 1)), function(x) {
      n = x - as.integer(hw)
      k = -0.5 * (a * n/hw)^2
      e^k
    })
    ret
  }
  w = makeWindow(windowLength, alpha[1])
  sizeW = length(w)
  sizeD = length(x)
  w = .normalize(w)
  hkwL = as.integer(sizeW/2)
  hkwR = sizeW - hkwL
  ret = sapply(c(1:sizeD), function(i) {
    ix.d = c((i - hkwL):(i + hkwR - 1))
    ix.w = which(ix.d %in% 1:sizeD)
    ix.d = ix.d[ix.w]
    W.nm = if(length(ix.w) != sizeW){.normalize(w[ix.w])}else{w}
    D.nm = x[ix.d]
    as.numeric(D.nm %*% W.nm)
  })
  if (!tails) {
    ret[c(1:hkwL, (sizeD - hkwR + 1):sizeD)] = NA
  }
  ret
}

#' Smooth Numerical Data
#' 
#' @description Helper function to smooth numerical data using methods specified by the user. 
#' 
#' @details At this moment in time, the only method is the \code{'gaussian'} window function (similar to the Matlab 
#' Gaussian Window Smoothing Function) and a number of moving averages \code{'sma', 'ema', 'dema'} or \code{'wma'}. 
#' These are functions that allows the user to smooth an input vector, returning vector of the same length as the input. 
#' This can also be achieved using the specific \code{\link{smth.gaussian}} function.
#' @param x numeric vector of values to smooth
#' @param method one of \code{'gaussian', 'sma', 'ema', 'dema'} or \code{'wma'}.
#' @param ... any other arguments to be passed to each specific smoothing methodology.
#' @return a numeric vector of same length as input \code{'x'} vector
#' @references If the \code{'method'} argument is equal to \code{'gaussian'}, then this function is a port of the function 
#' described here: \url{https://goo.gl/HGM47U}, very loosly based of code which has also been ported to c++ elsewhere
#' @seealso Refer to specific man files: \code{\link{smth.gaussian}}, \code{\link[TTR]{SMA}}, \code{\link[TTR]{EMA}}, 
#' \code{\link[TTR]{DEMA}} or \code{\link[TTR]{WMA}}
#' @exportMethod
#' @examples
#' #Prepare Data
#' n  = 1000
#' x  = seq(-pi,pi,length.out=n)
#' y  = sin(x) + (runif(length(x))*0.1) #NOISY DATA
#' ys = smth(y,window = 0.1,method = "gaussian") #SMOOTHING
#' plot(x,y,type="l",col="red")
#' lines(x,ys,col="black",lwd=3)
#' title("Example Smoothing of Noisy Data")
#' @name smth
#' @rdname smth
#' @aliases smth sma ema dema wma gaussian
smth <- function(x       = stop("Numeric Vector 'x' is Required"),
                 method  = getOption('smoother.method'),
                 ...){
  
  #Local Variables
  methods.local = c('gaussian')
  methods.ttr   = c('sma','ema','dema','wma')
  args <- c(list(x),list(...))
  
  #Process
  if(method %in% methods.local){
    return(do.call(paste('smth.',method,sep=""),args))
  } else if(method %in% methods.ttr){
    return(do.call(toupper(method),args)) #IMPORTED FUNCTIONS FROM TTR PACKAGE.
  } else {
    stop(paste("The 'method' argument (",as.character(method),") can only be one of ['",
               paste(c(methods.local,methods.ttr),collapse="','"),"'] at this moment in time.",sep=""),call.=FALSE)
  }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/onLoad.R
\name{smth.options}
\alias{smth.options}
\title{Smoother Options}
\description{
Several Global Options have been declared, as described in this help file.
}
\details{
The following global options can be modified, to alter the default calculation behaviour.
\tabular{lll}{
\strong{NAME} \tab \strong{VALUE} \tab \strong{DESCRIPTION} \cr
  \code{smoother.gaussianwindow.alpha} \tab \code{2.5} \tab Alpha Value in Calculating Window \cr
  \code{smoother.window} \tab \code{0.1} \tab Width of Window \cr
  \code{smoother.method} \tab \code{'gaussian'} \tab Default Smoothing Method \cr
  \code{smoother.tails} \tab \code{FALSE} \tab Include tails in final vector \cr
  \code{smoother.verbose} \tab \code{FALSE} \tab Verbose Reporting \cr
}
}
\examples{
#Tighten the alpha term for this session.
options('smoother.gaussianwindow.alpha' = 1)

#Include the Tails in Final Calculation
options('smoother.tails' = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/smth-gaussian.R
\name{smth.gaussian}
\alias{smth.gaussian}
\title{Smooth Using Gaussian Window}
\usage{
smth.gaussian(
  x = stop("Numeric Vector 'x' is Required"),
  window = getOption("smoother.window"),
  alpha = getOption("smoother.gaussianwindow.alpha"),
  ...,
  tails = getOption("smoother.tails")
)
}
\arguments{
\item{x}{numeric vector of values to smooth, error will be thrown if not provided.}

\item{window}{the length of the smoothing window, if an integer, represents
number of items, else, if a value between \code{0} and \code{1}, represents the 
proportion of the input vector}

\item{alpha}{parameter to determine the breadth of the gaussian window, yielding more or less sensitive 
smoothing characteristics}

\item{...}{not used}

\item{tails}{Logical value as to whether the tail regions should be included or not.}
}
\description{
The specific function for smoothing using the gaussian window function
}
\examples{
  y  = runif(100)
  ys = smth.gaussian(y)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/smoother-package.R
\name{smoother}
\alias{smoother}
\title{Smooth Data in R}
\description{
\code{smoother} Package for the Smoothing of Numerical Data
}
\details{
\code{smoother} is presently limited to a port of the Matlab 'Gaussian Window' Function, 
as well as a limited number of moving averages (\code{sma, ema, dema} and \code{'wma'}). Code for the gaussian window 
function has been written locally within this package, however, the moving averages are called from the \link{TTR} package 
(\url{https://CRAN.R-project.org/package=TTR}) and are included as a matter of convenience.

For further information (and examples) with regards to utilizing the primary helper function, 
please refer to the \link{smth} function help file
}
\references{
The Gaussian Smoothing component of the \code{smoother} package has been loosley adapted from elsewhere
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/smth.R
\name{smth}
\alias{smth}
\alias{sma}
\alias{ema}
\alias{dema}
\alias{wma}
\alias{gaussian}
\title{Smooth Numerical Data}
\usage{
smth(
  x = stop("Numeric Vector 'x' is Required"),
  method = getOption("smoother.method"),
  ...
)
}
\arguments{
\item{x}{numeric vector of values to smooth}

\item{method}{one of \code{'gaussian', 'sma', 'ema', 'dema'} or \code{'wma'}.}

\item{...}{any other arguments to be passed to each specific smoothing methodology.}
}
\value{
a numeric vector of same length as input \code{'x'} vector
}
\description{
Helper function to smooth numerical data using methods specified by the user.
}
\details{
At this moment in time, the only method is the \code{'gaussian'} window function (similar to the Matlab 
Gaussian Window Smoothing Function) and a number of moving averages \code{'sma', 'ema', 'dema'} or \code{'wma'}. 
These are functions that allows the user to smooth an input vector, returning vector of the same length as the input. 
This can also be achieved using the specific \code{\link{smth.gaussian}} function.
}
\examples{
#Prepare Data
n  = 1000
x  = seq(-pi,pi,length.out=n)
y  = sin(x) + (runif(length(x))*0.1) #NOISY DATA
ys = smth(y,window = 0.1,method = "gaussian") #SMOOTHING
plot(x,y,type="l",col="red")
lines(x,ys,col="black",lwd=3)
title("Example Smoothing of Noisy Data")
}
\references{
If the \code{'method'} argument is equal to \code{'gaussian'}, then this function is a port of the function 
described here: \url{https://goo.gl/HGM47U}, very loosly based of code which has also been ported to c++ elsewhere
}
\seealso{
Refer to specific man files: \code{\link{smth.gaussian}}, \code{\link[TTR]{SMA}}, \code{\link[TTR]{EMA}}, 
\code{\link[TTR]{DEMA}} or \code{\link[TTR]{WMA}}
}
